#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define int int64_t

const int MAXN = 1e5;

struct El {
    int t, i, a;
    El(int t = 0, int i = -1, int a = 0):
        t(t), i(i), a(a) {}
};

bool operator <(El a, El b) { return make_pair(a.t, a.i) < make_pair(b.t, b.i); }

int cur_time = 0;

set <El> queries;
set <El> f;
map <int, vector <El> > p;
map <int, vector <El> > kek;
int res[MAXN];

void push() {
    El e = (*f.begin());
    f.erase(f.begin());
    p[e.a].push_back(e);
}

void upd_time(int add) {
    cur_time = add;
    while (!f.empty() && (*f.begin()).t <= cur_time)
        push();
}

void ride(int floor, int time) {

    //cout << "Time " << time << " : ride to floor " << floor << endl;
    upd_time(time + floor - 1);
    int last_time = cur_time;
    upd_time(cur_time + floor - 1);

    kek.clear();
    while (!p.empty() && (*p.begin()).first <= floor) {
        kek[-(*p.begin()).first] = (*p.begin()).second;
        p.erase(p.begin());
    }

    while (!kek.empty()) {
        pair <int, vector <El> > c = (*kek.begin());
        kek.erase(kek.begin());

        int tm = last_time + (floor + c.first);

        for (int i = 0; i < (int)c.second.size(); i++) {
            if (c.second[i].t <= tm) {
                res[c.second[i].i] = cur_time;
                //cout << "   grab " << c.second[i].i + 1 << " : res is " << cur_time << endl;
            } else {
                f.insert(c.second[i]);
                p[-c.first].push_back(c.second[i]);
            }
        }
    }
}

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stout));

    ios_base::sync_with_stdio(false);

    int n, m; cin >> n >> m;

    fill(res, res + n, -1);

    for (int i = 0; i < n; i++) {
        int a, t; cin >> t >> a;
        queries.insert(El(t, i, a));
        f.insert(El(t, i, a));
    }

    while (!queries.empty()) {
        int a = (*queries.begin()).a;
        int t = (*queries.begin()).t;
        int id = (*queries.begin()).i;
        queries.erase(queries.begin());

        if (res[id] == -1)
            ride(a, max(cur_time, t));
    }

    for (int i = 0; i < n; i++)
        cout << res[i] << " ";
    cout << endl;

    return 0;
}
