#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <ctime>

using namespace std;

#define int int64_t

const int MAXN = 500;
const int INF = 1e16;

vector <pair <int, char> > gr[MAXN];
map <string, int> p;
bool ahaha[MAXN];
int parent[MAXN];
char ch_up[MAXN];

vector <pair <int, string> > f;

int n;
int dp[MAXN][MAXN];

int dfs(int v, int up, int deep) {
    if (dp[v][up] != INF + 1)
        return dp[v][up];
    string cur = "";
    int u = v;
    for (int i = 0; i < up; i++)
        cur += ch_up[u], u = parent[u];
    reverse(cur.begin(), cur.end());

    if (deep + 1 >= up)
        dp[v][up] = dfs(v, up + 1, deep);
    else
        dp[v][up] = INF;

    if (p.count(cur)) {
        int kek = 0;
        for (int i = 0; i < (int)gr[v].size(); i++)
            kek += dfs(gr[v][i].first, 1, deep + 1);
        dp[v][up] = min(dp[v][up], kek + p[cur]);
    } else {
        for (int i = 0; i < (int)gr[v].size(); i++) {
            int kek = 0;
            for (int j = 0; j < (int)gr[v].size(); j++) {
                if (i != j)
                    kek += dfs(gr[v][j].first, 1, deep + 1);
                else
                    kek += dfs(gr[v][i].first, up + 1, deep + 1);
            }
            dp[v][up] = min(dp[v][up], kek);
        }
    }

    return dp[v][up];
}

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int m, t; cin >> n >> m >> t;
    string h = "";
    bool flag2 = true;
    for (int i = 1; i < n; i++) {
        int p; cin >> p; p--;
        if (p + 1 != i)
            flag2 = false;
        char k; cin >> k;
        h += k;
        gr[p].push_back(make_pair(i, k));
        parent[i] = p;
        ch_up[i] = k;
    }
    bool flag1 = true;

    for (int i = 0; i < m; i++) {
        int cost; cin >> cost;
        string cur; cin >> cur;
        if (p.count(cur))
            p[cur] = min(p[cur], cost);
        else
            p[cur] = cost;
        if ((int)cur.length() > 1)
            flag1 = false;
        f.push_back(make_pair(cost, cur));
    }

    if (flag1) {
        int res = 0;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < (int)gr[i].size(); j++) {
                string h = "";
                h += gr[i][j].second;
                res += p[h];
            }
        cout << res << endl;
    } else if (flag2) {
        n = (int)h.size();
        vector <int> dp(n + 1, INF);
        dp[0] = 0;
        for (int j = 0; j < n; j++)
            for (int i = 0; i <= j; i++) {
                string cur = "";
                int kek = INF;
                for (int p = i; p <= j; p++) {
                    cur += h[p];
                    kek = min(kek, dp[p]);
                }
                if (p.count(cur))
                    dp[j + 1] = min(dp[j + 1], kek + p[cur]);
            }

        if (dp[n] >= INF)
            cout << -1 << endl;
        else
            cout << dp[n] << endl;
    } else {
        for (int i = 0; i <= n; i++)
            for (int j = 0; j <= n; j++)
                dp[i][j] = INF + 1;
        int res = dfs(0, 0, 0);
        if (res >= INF)
            cout << -1 << endl;
        else
            cout << res << endl;
    }

    //cout << (double)clock() / (double)CLOCKS_PER_SEC << endl;

    return 0;
}
