#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define int int64_t

const int MAXN = 1e5;
const int INF = 1e18;

vector <pair <int, char> > gr[MAXN];
map <string, int> p;
bool ahaha[MAXN];

vector <pair <int, string> > f;

vector <int> kek[100][100];
string lol[100][100];
vector <int> subtree[100];
int kekost[100][100];

void dfs(int v) {
    kek[v][v] = {v};
    for (int i = 0; i < (int)gr[v].size(); i++) {
        int to = gr[v][i].first;
        dfs(to);
        for (int j = 0; j < (int)subtree[to].size(); j++)
            subtree[v].push_back(subtree[to][j]);
        subtree[v].push_back(to);
        subtree[to].push_back(to);
        for (int j = 0; j < (int)subtree[to].size(); j++) {
            int cur = subtree[to][j];
            kek[v][cur].push_back(v);
            for (int i = 0; i < (int)kek[to][cur].size(); i++)
                kek[v][cur].push_back(kek[to][cur][i]);
            lol[v][cur] = gr[v][i].second + lol[to][cur];
        }
        subtree[to].pop_back();
    }
}

int answer = INF;
int curanswer = 0;
int n;

void kekmemmemkek() {
    if (curanswer > answer)
        return;

    bool solve = true;
    for (int i = 0; i < n; i++)
        if (ahaha[i] == 1)
            solve = false;
    if (solve) {
        answer = min(answer, curanswer);
        return;
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            if (kekost[i][j] != INF) {
                bool flag = false;
                for (int u = 1; u < (int)kek[i][j].size(); u++) {
                    if (ahaha[kek[i][j][u]])
                        flag = true;
                }
                if (flag) {
                    vector <int> omg;
                    for (int u = 1; u < (int)kek[i][j].size(); u++)
                        if (ahaha[kek[i][j][u]]) {
                            ahaha[kek[i][j][u]] = 0;
                            omg.push_back(kek[i][j][u]);
                        }
                    curanswer += kekost[i][j];

                    kekmemmemkek();

                    curanswer -= kekost[i][j];
                    for (int p = 0; p < (int)omg.size(); p++)
                        ahaha[omg[p]] = 1;
                }
            }
}

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int m, t; cin >> n >> m >> t;
    string h = "";
    bool flag2 = true;
    for (int i = 1; i < n; i++) {
        int p; cin >> p; p--;
        if (p + 1 != i)
            flag2 = false;
        char k; cin >> k;
        h += k;
        gr[p].push_back(make_pair(i, k));
    }
    bool flag1 = true;

    for (int i = 0; i < m; i++) {
        int cost; cin >> cost;
        string cur; cin >> cur;
        if (p.count(cur))
            p[cur] = min(p[cur], cost);
        else
            p[cur] = cost;
        if ((int)cur.length() > 1)
            flag1 = false;
        f.push_back(make_pair(cost, cur));
    }

    if (flag1) {
        int res = 0;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < (int)gr[i].size(); j++) {
                string h = "";
                h += gr[i][j].second;
                res += p[h];
            }
        cout << res << endl;
    } else if (flag2) {
        n = (int)h.size();
        vector <int> dp(n + 1, INF);
        dp[0] = 0;
        for (int j = 0; j < n; j++)
            for (int i = 0; i <= j; i++) {
                string cur = "";
                int kek = INF;
                for (int p = i; p <= j; p++) {
                    cur += h[p];
                    kek = min(kek, dp[p]);
                }
                if (p.count(cur))
                    dp[j + 1] = min(dp[j + 1], kek + p[cur]);
            }

        if (dp[n] >= INF)
            cout << -1 << endl;
        else
            cout << dp[n] << endl;
    } else {
        dfs(0);

        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                kekost[i][j] = INF;

        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                if (lol[i][j] != "")
                    if (p.count(lol[i][j]))
                        kekost[i][j] = p[lol[i][j]];
        fill(ahaha, ahaha + n, 1);
        ahaha[0] = 0;
        kekmemmemkek();

        if (answer >= INF)
            cout << -1 << endl;
        else
            cout << answer << endl;
    }

    return 0;
}
