#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <unordered_map>
#include <ctime>

using namespace std;

const int MAXN = 2e5;
const int INF = 2e9;

vector <pair <pair <int, int>, int> > c1;
int cff[MAXN];
int cfs[MAXN];
int cs[MAXN];
int csz = 0;

double get_time() { return (double)clock() / (double)CLOCKS_PER_SEC; }

int get_left(int l, int r) {
    int left = 0, right = csz;
    while (right - left > 1) {
        int mid = ((left + right) >> 1);
        if (cff[mid] > l)
            right = mid;
        else
            left = mid;
    }
    return left;
}

int get_right(int i, int l, int r) {
    int right = i;
    while (i < csz && cff[i] <= r && cfs[i] >= l)
        right++, i++;
    return right - 1;
}

unordered_map <long long, int> was[31];

long long M;

int get_dp(int l, int r, int col, int k) {
    if (was[k].count(M * l + col))
        return was[k][M * l + col];

    int left = get_left(l, r);
    int right = get_right(left, l, r);
    if (left == right) {
        was[k][M * l + col] = (col != cs[left]);
        return col != cs[left];
    }
    int mid = ((l + r) >> 1);
    int res = INF;
    for (int i = left; i <= right; i++)
        res = min(res, get_dp(l, mid, cs[i], k - 1) + get_dp(mid + 1, r, cs[i], k - 1) + (col != cs[i]));

    was[k][M * l + col] = res;

    return res;
}

int main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stout));

    ios_base::sync_with_stdio(false);

    int t, k; cin >> k >> t >> M;
    M++;
    for (int i = 0; i < t; i++) {
        int a, val; cin >> a >> val;
        if (!c1.empty() && c1.back().second == val)
            c1.back().first.second += a;
        else {
            if (!c1.empty())
                c1.push_back(make_pair(make_pair(c1.back().first.second + 1, c1.back().first.second + a), val));
            else
                c1.push_back(make_pair(make_pair(0, a - 1), val));
        }
    }

    for (int i = 0; i < (int)c1.size(); i++) {
        cff[i] = c1[i].first.first;
        cfs[i] = c1[i].first.second;
        cs[i] = c1[i].second;
    }
    csz = (int)c1.size();

    cout << get_dp(0, (1 << k) - 1, 0, k) << endl;

    return 0;
}
