#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <unordered_map>
#include <ctime>

using namespace std;

const int MAXN = 2e5;
const int INF = 2e9;
const int MAXM = 100;

vector <pair <pair <int, int>, int> > c1;
int cff[MAXN];
int cfs[MAXN];
int cs[MAXN];
int csz = 0;

double get_time() { return (double)clock() / (double)CLOCKS_PER_SEC; }

vector <int> get_(int l, int r) {
    int left = 0, right = csz;
    while (right - left > 1) {
        int mid = ((left + right) >> 1);
        if (cff[mid] > l)
            right = mid;
        else
            left = mid;
    }
    int i = left;
    vector <int> all;
    while (i < csz && cff[i] <= r && cfs[i] >= l) {
        all.push_back(cs[i]);
        i++;
    }
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());
    return all;
}

unordered_map <int, int> was[31][MAXM];

long long M;

int get_dp(int l, int r, int col, int k) {
    if (was[k][col].count(l))
        return was[k][col][l];

    vector <int> p = get_(l, r);
    if ((int)p.size() == 1) {
        was[k][col][l] = (col != p[0]);
        return col != p[0];
    }
    int mid = ((l + r) >> 1);
    int res = INF;
    for (int i = 0; i < (int)p.size(); i++)
        res = min(res, get_dp(l, mid, p[i], k - 1) + get_dp(mid + 1, r, p[i], k - 1) + (col != p[i]));

    was[k][col][l] = res;

    return res;
}

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stout));

    ios_base::sync_with_stdio(false);

    int t, k; cin >> k >> t >> M;
    M++;
    for (int i = 0; i < t; i++) {
        int a, val; cin >> a >> val;
        if (!c1.empty() && c1.back().second == val)
            c1.back().first.second += a;
        else {
            if (!c1.empty())
                c1.push_back(make_pair(make_pair(c1.back().first.second + 1, c1.back().first.second + a), val));
            else
                c1.push_back(make_pair(make_pair(0, a - 1), val));
        }
    }

    for (int i = 0; i < (int)c1.size(); i++) {
        cff[i] = c1[i].first.first;
        cfs[i] = c1[i].first.second;
        cs[i] = c1[i].second;
    }
    csz = (int)c1.size();

    cout << get_dp(0, (1 << k) - 1, 0, k) << endl;

    return 0;
}
