#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <unordered_map>
#include <ctime>

using namespace std;

const int MAXN = 2e5;
const int INF = 2e9;

vector <pair <pair <int, int>, int> > c1;
pair <pair <int, int>, int> c[MAXN];
int csz = 0;

double get_time() { return (double)clock() / (double)CLOCKS_PER_SEC; }

vector <int> get_all(int l, int r, int k) {
    int left = 0, right = csz;
    while (right - left > 1) {
        int mid = ((left + right) >> 1);
        if (c[mid].first.first > l)
            right = mid;
        else
            left = mid;
    }
    int i = left;
    vector <int> all;
    while (i < csz && c[i].first.first <= r && c[i].first.second >= l) {
        all.push_back(c[i].second);
        i++;
    }
    return all;
}

unordered_map <long long, int> was[31];

long long M;

int get_dp(int l, int r, int c, int k) {
    if (was[k].count(M * l + c))
        return was[k][M * l + c];

    vector <int> p = get_all(l, r, k);
    if ((int)p.size() == 1) {
        was[k][M * l + c] = (c != p[0]);
        return c != p[0];
    }
    was[k][M * l + c] = -1;
    int mid = ((l + r) >> 1);
    int res = INF;
    for (int i = 0; i < (int)p.size(); i++)
        res = min(res, get_dp(l, mid, p[i], k - 1) + get_dp(mid + 1, r, p[i], k - 1) + (p[i] != c));

    was[k][M * l + c] = res;

    return res;
}

int main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stout));

    ios_base::sync_with_stdio(false);

    int t, k; cin >> k >> t >> M;
    M++;
    for (int i = 0; i < t; i++) {
        int a, val; cin >> a >> val;
        if (!c1.empty() && c1.back().second == val)
            c1.back().first.second += a;
        else {
            if (!c1.empty())
                c1.push_back(make_pair(make_pair(c1.back().first.second + 1, c1.back().first.second + a), val));
            else
                c1.push_back(make_pair(make_pair(0, a - 1), val));
        }
    }

    for (int i = 0; i < (int)c1.size(); i++)
        c[i] = c1[i];
    csz = (int)c1.size();

    cout << get_dp(0, (1 << k) - 1, 0, k) << endl;

    //cout << get_time() << endl;

    return 0;
}
